<?php

Class SGallery extends Page {

    static $singular_name = 'SGallery';
    static $plural_name = 'SGalleries';
    static $icon = '';
    static $db = array(
        'GalleryDesc' => "HTMLText",

        'ItemsPerPage' => 'Int(2)',
        'ThumbnailImageWidth' => 'Int(4)',
        'ThumbnailImageHeight' => 'Int(4)',
        'FullImageWidth' => 'Int(4)',
        'FullImageHeight' => 'Int(4)',
        'ResizeMethod' => "Enum('CroppedImage,SetWidth,Setheight','CroppedImage')"
    );
    static $has_one = array(
        'CoverImage' => 'Image'
    );
    public static $has_many = array(
        'Images' => 'SGalleryimage'
    );
    public static $defaults = array(
        'ItemsperPage' => '10',
        'ThumbnailImageWidth' => '100',
        'ThumbnailImageHeight' => '100',
        'FullImageWidth' => '800',
        'FullImageHeight' => '600',
    );

    //*
    function getCMSFields() {
        $fields = parent::getCMSFields();
        /*
         *  Add extra basic fields to the CMS + Extra Tab 
         *  $newFieldsArray = list of fields need to be added to tab
         *  $newFieldsArray MUST be used to add array of fields as fields need to be declared before they can be added to a tab !
         */

        // Settings Tab
        $newFieldsArray = array(
            new UploadField("CoverImage"),
            new TextareaField("GalleryDesc"),
//            new DropdownField('ResizeMethod', 'ResizeMethod', singleton($this)->dbObject('ResizeMethod')->enumValues()),
            new TextField('ItemsPerPage'),
            new TextField('ThumbnailImageWidth'),
            new TextField('ThumbnailImageHeight'),
            new TextField('FullImageWidth'),
            new TextField('FullImageHeight')
        );


        /*
         * Add Gallery Section to the page using has_many relation + GridFeild 
         */
        $gridFieldConfig = GridFieldConfig_RelationEditor::create();
        $gridFieldConfig->addComponents(
                new GridFieldSortableRows("SortID")
        );


        $gridField = new GridField("SGalleryimages", "SGallery images", $this->Images(), $gridFieldConfig);

        /* Customize the List Display in the CMS 
         *         
          $gridField->getConfig()->getComponentByType('GridFieldDataColumns')->setDisplayFields(array(

          ));
         * 
         */


        /* Add Fields to tabs */
        $fields->addFieldsToTab("Root.Settings", $newFieldsArray, "");
        $fields->addFieldToTab("Root.GalleryImages", $gridField);

        return $fields;
    }


    function onBeforeWrite() {
        parent::onBeforeWrite();
        //$this->findOrMakeFolder();
    }

    function onBeforeDelete() {
        parent::onBeforeDelete();
    }

    public static $default_values = array(
    );

}

class SGallery_Controller extends Page_Controller {

    function init() {
        parent::init();
    }
    // RenderSGallery is Not completed yet !
    function RenderGallery($templatename="Default") {

        // checks if setPlugin is changed in the CMS 
        if (isset($this->setPlugin)) {
            $templatename = $this->setPlugin;
        }
        $renderWithArray = array(
            "SGallery-" . $templatename
        );

        if (isset($templatename)) {
            return $this->renderWith($renderWithArray);
        }
    }

    public function Pagination() {
        // More info at http://doc.silverstripe.org/framework/en/howto/pagination
        $PaginatedList = new PaginatedList($this->data()->Images(), $this->request);
        $PaginatedList -> setPagelength(2);
        return $PaginatedList;
    }


}

